﻿#pragma once
#include <optional>

namespace mirage_private {
    template <typename optional_type, bool has_intrusive_unset_optional_state>
    struct optional_storage;
}

namespace mirage {
    struct intrusive_unset_optional_state {
        template<typename>
        friend class std::optional;

        template<typename, bool>
        friend struct mirage_private::optional_storage;
    private:
        explicit intrusive_unset_optional_state() = default;
    };
}
